-- Create partition function
----------------------------
CREATE PARTITION FUNCTION PartitionByWeek (smalldatetime)
AS RANGE RIGHT 
FOR VALUES (
'2005-DEC-25',
'2006-JAN-01',
'2006-JAN-08',
'2006-JAN-15',
'2006-JAN-22',
'2006-JAN-29')
GO

-- Create file groups
---------------------

ALTER DATABASE	CDR
ADD FILEGROUP FG2005WK52;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2005WK52,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2005WK52.ndf',
    SIZE = 3MB, --3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2005WK52
GO

ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK01;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK01,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK01.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK01
GO


ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK02;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK02,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK02.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK02
GO

ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK03;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK03,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK03.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK03
GO

ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK04;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK04,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK04.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK04
GO

ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK05;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK05,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK05.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK05
GO

ALTER DATABASE	CDR
ADD FILEGROUP FG2006WK06;
GO
ALTER DATABASE	CDR
ADD FILE
(
    NAME = CD2006WK06,
    FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\Data\CD2006WK06.ndf',
    SIZE = 3MB,--3000MB,
    FILEGROWTH = 3MB --30MB
) TO FILEGROUP FG2006WK06
GO

-- Create partition scheme
--------------------------
CREATE PARTITION SCHEME WeeklyPartitionScheme
AS PARTITION PartitionByWeek
TO (FG2005WK52, FG2006WK01, FG2006WK02, FG2006WK03, FG2006WK04, FG2006WK05, FG2006WK06)
GO

-- Create fact table
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[FactCallDetail]') AND type in (N'U'))
DROP TABLE [dbo].[FactCallDetail]
GO
CREATE TABLE [dbo].[FactCallDetail](
	[TicketNumber] [varchar](15) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[CallDateKey] [smalldatetime] NOT NULL,
	[CallTimeKey] [smallint] NOT NULL,
	[OriginatingLocationKey] [int] NOT NULL,
	[OriginatingLocalNumber] [varchar](12) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[DestinationLocationKey] [int] NOT NULL,
	[DestinationLocalNumber] [varchar](12) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[CallTypeKey] [varchar](2) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	[Duration] [smallint] NOT NULL
) ON WeeklyPartitionScheme (CallDateKey)
GO
IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[FactCallDetail]') AND name = N'ix_CallDate')
CREATE NONCLUSTERED INDEX [ix_CallDate] ON [dbo].[FactCallDetail] 
(
	[CallDateKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[FactCallDetail]') AND name = N'ix_Destination')
CREATE NONCLUSTERED INDEX [ix_Destination] ON [dbo].[FactCallDetail] 
(
	[DestinationLocalNumber] ASC,
	[DestinationLocationKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO

IF NOT EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[FactCallDetail]') AND name = N'ix_Origin')
CREATE NONCLUSTERED INDEX [ix_Origin] ON [dbo].[FactCallDetail] 
(
	[OriginatingLocalNumber] ASC,
	[OriginatingLocationKey] ASC
)WITH (PAD_INDEX  = OFF, IGNORE_DUP_KEY = OFF) ON [PRIMARY]
GO